﻿/*
*
* Číselné datové typy
*
*/

-- ===================
-- Defualtní konverze
-- ===================

select 123 as integer,45.12 as numeric , -35.8e24 as numeric;

/*

 integer | numeric |           numeric
---------+---------+-----------------------------
     123 |   45.12 | -35800000000000000000000000
(1 řádka)

*/

-- =============
-- Celočíselné
-- =============

select 123::smallint,31235647::int,25639872565138706::bigint;

/*

 int2 |   int4   |       int8
------+----------+-------------------
  123 | 31235647 | 25639872565138706
(1 řádka)

*/


-- =============
-- Desetinné
-- =============

select  -35.8e24 :: numeric as numeric, -35.8e24 :: real as real;


/*

           numeric           |    real
-----------------------------+------------
 -35800000000000000000000000 | -3.58e+025
(1 řádka)

*/

select  4546446546546.457984654 :: decimal as decimal,4546446546546.457984654 :: real as real, 4546446546546.457984654::double precision;


/*

         decimal         |     real     |      float8
-------------------------+--------------+------------------
 4546446546546.457984654 | 4.54645e+012 | 4546446546546.46
(1 řádka)

*/



-- =============
-- Serial
-- =============

-- Aktivace datoveho typu serial

CREATE TABLE tablename (
    colname SERIAL
);

/*
-- Vytvoří se
-- Sequence: public.tablename_colname_seq

-- DROP SEQUENCE public.tablename_colname_seq;

CREATE SEQUENCE public.tablename_colname_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE public.tablename_colname_seq
  OWNER TO salko;

-- Taky se vygeneruje tabulka takto

-- Table: public.tablename

-- DROP TABLE public.tablename;

CREATE TABLE public.tablename
(
  colname integer NOT NULL DEFAULT nextval('tablename_colname_seq'::regclass)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE public.tablename
  OWNER TO salko;
  
*/

-- Výběr současné hodnoty
select currval('tablename_colname_seq'::regclass);


-- Zvýšení sekvence o 1

select nextval('tablename_colname_seq'::regclass);

-- Naposledy použitá sekvence hodnota
select lastval();

-- Nastavení běžné hodnoty
select setval('tablename_colname_seq'::regclass,100);
