﻿/*
*
*  Dátumové datové typy
*
*/

-- ===================
-- časové razítko
-- ===================

select current_timestamp, now(),now()::timestamp;

-- ===================
-- datum
-- ===================

select current_date, now()::date;


-- ===================
-- čas
-- ===================

select now()::time,current_time;

-- ===================
-- interval
-- ===================

select now() - '2016-03-13' as days, now() - '2016-03-13' as times;


drop table if exists pokus1;

-- ===================
-- Různé datumové typy 
-- ===================

create table pokus1
(id serial primary key,
 rozdil interval day,
 datum date default now()::date,
 cas_lokalni   time without time zone  default now()::time,
 cas_svetovi   time with time zone  default now()::time);

insert into pokus1 (rozdil)
values (now() - '1964-03-07')
returning *;

drop table if exists pokus1;

-- =============================================
-- Nastavení lokálního datového typu pro Japonsko
-- =============================================

-- Aktualni čas v japonsku
SET TIMEZONE TO 'Japan';
select now()::time with time zone, now()::time without time zone;

-- Nastavení času na lokální
SET TIME ZONE LOCAL;
select now()::time with time zone, now()::time without time zone;

-- ==============
-- Ruzné konverze
-- ==============

-- Ořezaní minut
select INTERVAL '-08:34:52' HOUR TO MINUTE ;

-- Převod text na datum
select to_date('12.3.2009 08:34:52','dd.mm.yyyy HH:MI:SS'), to_timestamp('12.3.2009 08:34:52','dd.mm.yyyy HH:MI:SS');

-- Kolik minut je dana hodnota
select INTERVAL '457898' MINUTE

-- Zobrazeni bezneho casoveho razitka s casovou zonou
select to_char(CURRENT_TIMESTAMP,'dd.mm.yyyy HH24:MI (TZ)') 
as datum_nemecky;
 

-- Prevod casu v timezone na cas ve stredni Evrope
select time with time zone '16:31:46.311947+09' AT TIME ZONE 'CET' 
as cas_lokalni;
